
								12 July 1993

             MPA FLASH SOFTWARE TEST AND VERIFICATION PLAN

This document is the test procedure for the computer side of the mpa radio
flash software.  It is meant to verify proper operation of the software.
The basic test is will it flash a radio and will it not lock up the computer.

EQUIPMENT:
----------
    1) An mpa radio, TQ3370 programmer box, and programming cable
    2) HP4915 serial port analyzer or equivilent
    3) IBM computer capable of editing and compiling the software.
    	(Microsoft C 5.0 or greater and Greenleaf Com libraries)
    4) Access to the edacs1 and mpa conventional personality programs
    5) Proper mpa flash code files for edacs and conventional

COMMAND LINE PARAMETER TESTS:
-----------------------------
 1.001	Run the program without any parameters.
	    The program shall display a help message

 1.002  Run the program with a filename as a parameter that does not
		exist in the directory.
	    The program shall print a file not found message and exit

 1.003  Run the program with a mpa filename as a parameter
	    The program shall try to flash the radio on COM1

 1.004	Run the program with the mpa filename plus a "-1" parameter
	    The program shall try to flash the radio on COM1

 1.005	Run the program with the mpa filename plus a "-2" parameter
	    The program shall try to flash the radio on COM2

 1.006	Run the program with the mpa filename plus a "-x" parameter
		where x is a number greater than the computer's number
		of com ports
	    The program shall say it can't find the com port and abort


GET PERSONALITY TESTS:
----------------------
 2.001	Try to flash a conventional mpa radio.
	    The software must report a 8k personality size

 2.002      The software must report the proper flash code revision

 2.003  The software must read in and successfully compare an 8k
		personality before going into the flash mode.


 2.011	Try to flash a edacs mpa radio.
	    The software must report a 6k personality size

 2.012      The software must report the proper flash code revision

 2.013  The software must read in and successfully compare an 6k
		personality before going into the flash mode.


 2.020  Run the flash program with the radio initially turned off.
	    The program shall say it is trying to find the radio

 2.021  Press any key while hung in this mode. 
	    The program shall go and start flashing the radio

 2.022  Run the flash program with the radio initially turned off.
	    The program shall say it is trying to find the radio

 2.023  Turn the radio on
	    The program should reconize the radio and begin saving
	    the personality.


 2.030  Add code after the personality has been read in to purposely
		corrupt the stored array.  Trigger this code only on
		the first file through the for loop.  Compile and
		run this new code.
	    The compare should then fail.  The program will attempt to
	    read and compare the personality again.

  2.031 Remove the added code and compile back to the release code.


  2.040 Attempt to flash a radio.  While the computer is reading in the
		personality, disconnect or short out the link from the
		radio to the computer.  This simulates the computer missing
		a personality byte.
	    The computer should hang up.  Pressing any key should cause it
	    to fail the compare and try to get the personality again.

  2.041 Attempt to flash a radio.  While the computer is comparing the
		personality, disconnect or short out the link from the
		radio to the computer.  This simulates the computer missing
		a personality byte.
	    The computer should hang up.  Pressing any key should cause it
	    to fail the compare and try to get the personality again.


  2.051 Attempt to flash a working radio.
	    The personality should be saved.
	    The radio should flash
	    The personality should be compared for a change due to flashing

  2.052	Attempt a flash a mpa without valid flash software.
	    The radio should hang while looking for the radio to go into
	    programming mode.

  2.053 Press any key with the computer hung
	    The program should proceed with the flash process
	    The program shall print a error and exit instead of trying to
		compare personality.


FLASH TESTS:
-------------
 3.000	Try to flash the radio.
	    Verify program handles dtr line properly.

 3.001      Verify program waits at least five seconds from changing dtr
	    to sending 'DEREK

 3.002      Verify program responds with zero flash command after radio
	    sends response from 'DEREK

 3.003	    Verify program responds with erase flash command after radio
	    responds from zero command

 3.004	    Verify radio starts sending data after radio responds from
	    the zero command

 3.005	    Compare a few lines of binary data from the serial port analyzer
	    to the information in the radio file.

 3.006      Verify program handles the last line of data in the radio file
	    ending flashing and saying the radio flashed correctly

 3.007	    Verify program handles dtr properly after flashing radio.

 3.008	Create a new radio test file by taking an existing test file and
	removing the last line of code.  (The :00000001) line.
	    The radio shall still flash normally.  The program will give
	    a successful completion and not hang up or give a file error
	    message.

 3.010	Try to flash the radio.  While it is waiting for a response to the
		zero command, press any key
	    The program shall set dtr properly and exit

 3.012	Try to flash the radio.  While it is waiting for a response to the
		erase command, press any key
	    The program shall set dtr properly and exit

 3.013	Try to flash the radio.  While it is sending data, press any key
	    The program shall set dtr properly and exit

 3.014	Try to flash the radio.  While it is sending data, disconnect or short
		the link to the radio.
	    The program shall hang until any key is pressed.  It shall then
	    set dtr properly and exit


COMPARE PERSONALITY TESTS:
----------------------------
 4.000	Add code before the first compare test to save a couple of bytes in
		the array.  Then purposely corrupt those bytes.  Change the
		corrupted bytes back at the end of the first compare.  Compile
		and use this version for further testing.  Try to flash a
		radio.
	    The program shall fail the first of the compare operations

 4.001	    The program shall pass the second of the two compare operations
	    It shall then print a successful message and exit

 4.002	Change the restoration of the corrupted bytes to after the second
		compare operation.  Recompile and use this version for further
		testing.  Try to flash a radio.
	    The program shall fail the first compare.

 4.003	    The program shall fail the second compare.

 4.004	    The program shall write the personality back to the radio.

 4.005	    The program shall then compare the personality from the radio
	    with the array.  If successful, the program shall print
	    a successful message and exit

 4.010	Change the program so the corrupted bytes are never restored.  Compile
		and use this version to for further testing.  Try to flash a
		radio.

 4.011	    The radio shall fail the first compare.
 4.012	    The radio shall fail the second compare.
 4.013	    The radio will enter a loop of write the personality and compare
	    the personality.  Since this is forced to not compare, the loop
	    will run ten times before the program prints a give up message
	    and exits.

 4.014	Try and flash the radio.  At any time during the compare, press any
		key.
	    The radio will print a give up message and exit

 4.020  Remove the test part of the code from the program.  Recompile and
		use this version for further testing.  Try and flash a radio.
	    The program shall compare successfully.  It will then print a
	    successful message and exit.

 4.021	Try and flash a radio.  Disconnect the link between the radio and
		computer while in the final compare.
	    The computer shall hang.  Upon pressing any key, it shall resume
	    as though there is a bad compare operation.

 4.030	Write a known good personality from the radio's pc programming
		software.  Try to flash the radio.  Then read the radio
		with the pc programming software.  Compare with the original
		pc programming file.
	    No items in the pc programming file shall have changed.


FINAL TESTS:
--------------
 5.000	Flash a radio with all current versions of mpa software that support
		that radio.

 5.010  Flash a radio at least fifty times.  Try to get a feel for what if
		anything is not going right.
